routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::middleware(['auth'])->group(function () {
    
    /* Resources */
    Route::resource('faculties', 'FacultyController');
    Route::resource('posts', 'PostController');
    Route::resource('universities', 'UniversityController');
    
    /* Custom */
    Route::get('profile', 'ProfileController@show');
});

app/Post.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    protected $fillable = ['title', 'content', 'subject_id', 'user_id'];

    public function subject(){
        return $this->belongsTo('App\Subject');
    }

    public function user(){
        return $this->belongsTo('App\User');
    }

    public function getIsRecentAttribute(){
        return \Carbon\Carbon::now()->diffInDays($this->created_at) <= 1;
    }

    public function imagenes(){
        return $this->hasMany('App\Media');
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Post;
use App\Subject;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Auth;

class PostController extends Controller
{

    public function __construct()
    {     
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $posts = Post::with('user')
            ->with('subject')
            ->orderBy('created_at', 'desc')
            ->paginate(15);
        return view('posts.index', [
            'posts' => $posts
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $subjects = Subject::select('id','name')->get();
        return view('posts.create', [
            'subjects' => $subjects
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'title'=>'required',
            'content'=>'required',
            'subject_id' =>'required',
        ]);

        $path = Storage::putFile('public/post_files',$request->file('attachment'));

        $post = new Post([
            'title' => $request->get('title'),
            'content' => $request->get('content'),
            'user_id' => Auth::user()->id,
            'subject_id' => $request->get('subject_id'),    
            'attachment_url' => $path,                    
        ]);
        $post->save();
        return redirect('/posts')->with('success', '¡Mensaje creado con éxito!');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function show(Post $post)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function edit(Post $post)
    {
        $this->authorize('update', $post);
        
        $subjects = Subject::select('id','name')->get();
        return view('posts.edit', [
            'subjects' => $subjects,
            'post' => $post
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Post $post)
    {
        $this->authorize('update', $post);
        
        $request->validate([
            'title'=>'required',
            'content'=>'required',
            'subject_id'=>'required'
        ]);

        $post->title =  $request->get('title');
        $post->content = $request->get('content');
        $post->subject_id = $request->get('subject_id');
        $post->save();

        return redirect('/posts')->with('success', '¡Publicacion actualizada!');
         
        
        //return redirect('/posts')->with('error', 'No tiene permisos');
        
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Post  $post
     * @return \Illuminate\Http\Response
     */
    public function destroy(Post $post)
    {
        //
    }
}

resources/views/posts/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
<div class="row justify-content-center mb-4">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Nuevo mensaje</div>

                <div class="card-body">
                  <form class="" method="post" action="{{ route('posts.store') }}" enctype="multipart/form-data">  
                  @csrf
                  @if ($errors->any())
                  <div class="alert alert-danger">
                      <ul>
                          @foreach ($errors->all() as $error)
                          <li>{{ $error }}</li>
                          @endforeach
                      </ul>
                  </div>
                  <br /> 
                  @endif

                  <div class="form-group">
                    <label class="my-1 mr-2" for="subject_id">Materia</label>
                    <select class="form-control custom-select my-1 mr-sm-2" name="subject_id">
                        <option selected disabled>Seleccionar materia...</option>
                        @foreach ($subjects as $subject)
                        <option value="{{ $subject->id }}">{{ $subject->name }}</option>                        
                        @endforeach
                    </select>
                  </div>
                  
                  <div class="form-group">
                    <label for="title">Titulo:</label>
                    <input type="text" class="form-control" name="title" value="" />
                  </div>

                  <div class="form-group">
                    <label for="content">Mensaje:</label>
                    <textarea class="form-control" name="content" rows="3"></textarea>
                  </div>

                  <div class="form-group">
                    <label for="attachment_url">Adjunto:</label>
                    <input type="file" id="imagesToUpload" name="imagesToUpload[]" multiple>
                  </div>

                  <button type="submit" class="btn btn-primary">Publicar comentario</button>
                </form>
              </div>
            </div>
        </div>
    </div>
</div>

@endsection

resources/views/posts/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
<div class="row justify-content-center mb-4">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Editar publicación</div>

                <div class="card-body">
                  <form class="" method="post" action="{{ route('posts.update', $post->id) }}">  
                  @method('PATCH') 
                  @csrf
                  @if ($errors->any())
                  <div class="alert alert-danger">
                      <ul>
                          @foreach ($errors->all() as $error)
                          <li>{{ $error }}</li>
                          @endforeach
                      </ul>
                  </div>
                  <br /> 
                  @endif

                  <div class="form-group">
                    <label class="my-1 mr-2" for="subject_id">Materia</label>
                    <select class="form-control custom-select my-1 mr-sm-2" name="subject_id">
                        <option disabled>Seleccionar materia...</option>
                        @foreach ($subjects as $subject)
                        <option selected="{{ $post->subject_id == $subject->id }}" value="{{ $subject->id }}">{{ $subject->name }}</option>                        
                        @endforeach
                    </select>
                  </div>
                  
                  <div class="form-group">
                    <label for="title">Titulo:</label>
                    <input type="text" class="form-control" name="title" value="{{ $post->title }}" />
                  </div>

                  <div class="form-group">
                    <label for="content">Mensaje:</label>
                    <textarea class="form-control" name="content" rows="3" >{{ $post->content }}</textarea>
                  </div>

                  <div class="form-group">
                    <label for="attachment_url">Adjunto (URL):</label>
                    <input type="text" class="form-control" name="attachment_url" value="{{ $post->attachment_url }}" />
                  </div>

                  <button type="submit" class="btn btn-primary">Actualizar publicación</button>
                </form>
              </div>
            </div>
        </div>
    </div>
</div>

@endsection

resources/views/posts/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
<div class="row justify-content-center mb-4">

        <div class="col-md-8">
            @if (session('success'))
                <div class="alert alert-success">
                    {{ session('success') }}
                </div>
            @endif
            <div class="card mb-4">
              <div class="card-body">
                  <h5 class="card-title">Publicar nuevo mensaje!</h5>
                  <p class="card-text">¿Tenés material para compartir? Compartilo acá</p>
                  <a href="{{ route('posts.create') }}" class="btn btn-primary">Compartir</a>
              </div>
            </div>
            <div class="card">
                <div class="card-header">Ultimas publicaciones</div>

                <div class="card-body">
                  <div class="card-deck">
                  @foreach ($posts as $post)
                    <div class="card">           
                      @if ( !empty($post->attachment_url) ) 
                      <img class="card-img-top" src="{{ Storage::url($post->attachment_url) }}" alt="{{ $post->title }}">
                      @endif
                      <div class="card-body">
                        <h5 class="card-title">{{ $post->title }}</h5>
                        <p class="card-text text-right"><small class="text-muted">Creado {{ $post->created_at->ago() }}</small></p>                        
                        <p class="card-text">{{ Str::limit($post->content,'50', '...') }}</p>
                        <a href="{{ route('posts.show',$post->id) }}" class="card-link">Ver publicación</a>
                        <p class="card-text"><small class="text-muted">Por {{ $post->user->name }} en {{ $post->subject->name }}</small></p>
                        @can('update',$post)
                          <a href="{{ route('posts.edit',$post->id) }}" class="btn btn-primary">Editar</a>
                        @endcan
                      </div>                      
                    </div>
                  @endforeach
                  </div>
                </div>
            </div>
        </div>
    </div>
</div>

@endsection